' BUDGET PROGRAM
' This program will load account information and categorize
' amounts and compare with budget amounts.

budgetloaded = 0
accountloaded = 0
accountcategorized = 0

' DEFINING ARRAYS

' $DYNAMIC

'These variables will allow for arrays to grow in size
totalitems = 100
incheadings = 10
fexpheadings = 10
vexpheadings = 20
numperincheading = 20
numperfexpheading = 20
numpervexpheading = 20
incdescperheading = 50
fexpdescperheading = 50
vexpdescperheading = 50

' Account Data
DIM idate$(totalitems), idesc$(totalitems), idebit(totalitems), icredit(totalitems)
accountscategorized$ = "" 'name of string variable that contains file names
'                          of accounts already categorized
lastdatecategorized$ = ""


' Budget/Category Headings and Amounts
' (Income, Fixed Expenses, and Variable Expenses)
DIM budinc$(incheadings), budfexp$(fexpheadings), budvexp$(vexpheadings)
DIM budincamt(incheadings) AS INTEGER, budfexpamt(fexpheadings) AS INTEGER, budvexpamt(vexpheadings) AS INTEGER

' Category Date, Descriptions and Amounts
DIM incdate$(incheadings, numperincheading), fexpdate$(fexpheadings, numperfexpheading), vexpdate$(vexpheadings, numpervexpheading)
DIM incdesc$(incheadings, numperincheading), fexpdesc$(fexpheadings, numperfexpheading), vexpdesc$(vexpheadings, numpervexpheading)
DIM incamt(incheadings, numperincheading) AS INTEGER, fexpamt(fexpheadings, numperfexpheading) AS INTEGER, vexpamt(vexpheadings, numpervexpheading) AS INTEGER

' Category Descriptions
' (x,y) where x is associated with a category heading
DIM inccatdesc$(incheadings, incdescperheading), fexpcatdesc$(fexpheadings, fexpdescperheading), vexpcatdesc$(vexpheadings, vexpdescperheading)

'Report Data
DIM catincamt(incheadings)
DIM catfexpamt(fexpheadings)
DIM catvexpamt(vexpheadings)


10
'MENU
CLS
PRINT
PRINT "BankLoad(c) BUDGET PROGRAM"
PRINT
PRINT "What would like to do?"
PRINT
PRINT "1. Create Budget."
PRINT "2. Load Budget."
PRINT "3. View Budget."
PRINT "4. Edit Budget."
PRINT "5. Save Budget."
PRINT "6. Load Account."
PRINT "7. View Account."
PRINT "8. Categorize Account Entries."
PRINT "9. View Current Categorized Account Data."
PRINT "10. Compare Current Values with Budget Values."
PRINT "11. View Category Descriptions."
PRINT "12. Edit Category Descriptions."
PRINT "99. End Program"
PRINT

choice = 0
789

INPUT choice
IF choice = 0 THEN GOTO 10

IF choice = 1 THEN GOSUB createbudgetfile
IF choice = 2 THEN GOSUB loadbudgetfile
IF choice = 3 THEN GOSUB viewbudget
IF choice = 4 THEN GOSUB editbudgetfile
IF choice = 5 THEN GOSUB savebudgetfile
IF choice = 6 THEN GOSUB loadaccount
IF choice = 7 THEN GOSUB viewaccount
IF choice = 8 THEN GOSUB categorize
IF choice = 9 THEN GOSUB currentreport
IF choice = 10 THEN GOSUB compare
IF choice = 11 THEN GOSUB viewdescriptions
IF choice = 12 THEN GOSUB editdescriptions


IF choice = 99 THEN
   SYSTEM
   END
END IF
GOTO 10



loadaccount:
accountcategorized = 0
accountloaded = 1

REDIM idate$(totalitems), idesc$(totalitems), idebit(totalitems), icredit(totalitems)
CLS
PRINT
PRINT "Available Account Files:"
PRINT
CHDIR "D:\finance\basicp~2"
FILES "*.csv"
PRINT
PRINT "Please enter name of account file to load."
PRINT "(Type name exactly as it appears above, omit '.csv')"
555
INPUT account$
IF account$ = "" THEN GOTO 555
account$ = account$ + ".csv"
OPEN account$ FOR INPUT AS #1
i = 1
DO UNTIL (EOF(1))
   LINE INPUT #1, line$
   IF line$ = "" THEN GOTO 987
   a = 0
   b = 0
   c = 0
   d = 0
   t = 1
   length = LEN(line$)
   DO WHILE t <= length
      IF MID$(line$, t, 1) = "," THEN
         IF d = 0 AND c <> 0 THEN d = t
         IF c = 0 AND b <> 0 THEN c = t
         IF b = 0 AND a <> 0 THEN b = t
         IF a = 0 THEN a = t
      END IF
      t = t + 1
   LOOP
   idate$(i) = LEFT$(line$, a - 1)
   idesc$(i) = MID$(line$, a + 1, b - a - 1)
   idebit(i) = VAL(MID$(line$, b + 1, c - b - 1))
   icredit(i) = VAL(MID$(line$, c + 1, d - c - 1))
   i = i + 1
LOOP
987
items = i - 1
CLOSE
RETURN















viewaccount:

IF accountloaded = 0 THEN
   CLS
   PRINT
   PRINT "Please load an account first!"
   SLEEP
   RETURN
END IF


CLS
PRINT "Date", "Description", , "Debit", "Credit"
FOR x = 1 TO items
   IF LEN(idesc$(x)) <= 11 THEN PRINT idate$(x), idesc$(x), , idebit(x), icredit(x)
   IF LEN(idesc$(x)) > 11 THEN PRINT idate$(x), idesc$(x), idebit(x), icredit(x)
   IF x / 20 = 1 OR x / 20 = 2 OR x / 20 = 3 OR x / 20 = 4 OR x / 20 = 5 OR x / 20 = 6 THEN
      SLEEP
      CLS
      PRINT "Date", "Description", "Debit", "Credit"
   END IF
NEXT x
SLEEP
RETURN














categorize:

IF budgetloaded = 0 THEN
   CLS
   PRINT
   PRINT "Please create or load a budget first!"
   SLEEP
   RETURN
END IF

IF accountloaded = 0 THEN
   CLS
   PRINT
   PRINT "Please load an account first!"
   SLEEP
   RETURN
END IF

IF accountcategorized = 1 THEN
   CLS
   PRINT
   PRINT "This account has already been categorized! Please load another."
   SLEEP
   RETURN
END IF

PRINT "Please enter the date this account was downloaded. (No commas)"
INPUT lastdatecategorized$
accountcategorized = 1
accountscategorized$ = accountscategorized$ + ", " + account$

CLS
PRINT
PRINT "Assigning Account Entries to Budget Categories..."
PRINT
SLEEP

'place holders to keep track of where to put new items
'Will need to load non-one values to add additional account data



'incplace = 1
'fexpplace = 1
'vexpplace = 1




FOR i = 1 TO items
   found = 0 ' If found still = 0 after all this, need to create new description
  
   'Check Income Descriptions
   FOR x = 1 TO incheadings
      FOR y = 1 TO incdescperheading
         IF inccatdesc$(x, y) <> "" THEN ' Only check if something there
            desclength = LEN(inccatdesc$(x, y)) ' Only need to check these characters
            IF inccatdesc$(x, y) = LEFT$(idesc$(i), desclength) THEN
               found = 1
               firstopenfound = 0
               FOR z = 1 TO numperincheading
                  IF incdate$(x, z) = "" AND firstopenfound = 0 THEN
                     incdate$(x, z) = idate$(i)
                     incdesc$(x, z) = idesc$(i)
                     IF icredit(i) = 0 THEN incamt(x, z) = idebit(i) * -1
                     IF idebit(i) = 0 THEN incamt(x, z) = icredit(i)
                     firstopenfound = 1
                  END IF
               NEXT z
            END IF
         END IF
      NEXT y
   NEXT x
  
   'Check Fixed Expense Descriptions
   FOR x = 1 TO fexpheadings
      FOR y = 1 TO fexpdescperheading
         IF fexpcatdesc$(x, y) <> "" THEN ' Only check if something there
            desclength = LEN(fexpcatdesc$(x, y))
            IF fexpcatdesc$(x, y) = LEFT$(idesc$(i), desclength) THEN
               found = 1
               firstopenfound = 0
               FOR z = 1 TO numperfexpheading
                  IF fexpdate$(x, z) = "" AND firstopenfound = 0 THEN
                     fexpdate$(x, z) = idate$(i)
                     fexpdesc$(x, z) = idesc$(i)
                     IF icredit(i) = 0 THEN fexpamt(x, z) = idebit(i)
                     IF idebit(i) = 0 THEN fexamt(x, z) = icredit(i) * -1
                     firstopenfound = 1
                  END IF
               NEXT z
            END IF
         END IF
      NEXT y
   NEXT x


   'Check Variable Expense Descriptions
   FOR x = 1 TO vexpheadings
      FOR y = 1 TO vexpdescperheading
         IF vexpcatdesc$(x, y) <> "" THEN ' Only check if something there
            desclength = LEN(vexpcatdesc$(x, y))
            IF vexpcatdesc$(x, y) = LEFT$(idesc$(i), desclength) THEN
               found = 1
               firstopenfound = 0
               FOR z = 1 TO numpervexpheading
                  IF vexpdate$(x, z) = "" AND firstopenfound = 0 THEN
                     vexpdate$(x, z) = idate$(i)
                     vexpdesc$(x, z) = idesc$(i)
                     IF icredit(i) = 0 THEN vexpamt(x, z) = idebit(i)
                     IF idebit(i) = 0 THEN vexpamt(x, z) = icredit(i) * -1
                     firstopenfound = 1
                  END IF
               NEXT z
            END IF
        END IF
      NEXT y
   NEXT x

  
  
  
  
   IF found = 0 THEN 'haven't found a description
      CLS
      PRINT
      PRINT "There is no associated description for the following item:"
      
     
      PRINT
      PRINT "Date", "Description", , "Debit", "Credit"
      IF LEN(idesc$(i)) <= 11 THEN PRINT idate$(i), idesc$(i), , idebit(i), icredit(i)
      IF LEN(idesc$(i)) > 11 THEN PRINT idate$(i), idesc$(i), idebit(i), icredit(i)
      
     
      PRINT
      PRINT "Please assign to a heading."
      
     
      PRINT
      PRINT "Choose type of item:"
      PRINT
      PRINT "1. Income"
      PRINT "2. Fixed Expense"
      PRINT "3. Variable Expense"
      PRINT "4. IGNORE"

      itemtype = 0
345
      INPUT itemtype
      IF itemtype = 0 THEN GOTO 345
     
     




      IF itemtype = 4 THEN GOTO 147
     
      IF itemtype = 1 THEN
         CLS
         PRINT
         PRINT "Choose type of income: (Enter Item #)"
         PRINT "(Select next blank item to add a new category.)"
         PRINT
         PRINT "Item", "Type"
         FOR x = 1 TO incheadings
            PRINT x, budinc$(x)
         NEXT x
        
         inctype = 0
346
         INPUT inctype
         IF inctype = 0 THEN GOTO 346
        
         IF budinc$(inctype) = "" THEN 'this is a new type of budget heading
99
           
            PRINT
            PRINT "Enter a Heading for this new type of Income."
            INPUT budinc$(inctype)
            PRINT
            PRINT budinc$(inctype)
            PRINT "Is this correct? (Y/N)"
         
            correct$ = ""
993
            INPUT correct$
            IF correct$ = "" THEN GOTO 993

            IF correct$ = "n" OR correct$ = "N" THEN GOTO 99
       
            PRINT
            PRINT "Now you must enter a budget amount for this heading."
            PRINT "You can edit this value later."
         
            buudincamt(inctype) = 0
881
            INPUT budincamt(inctype)
            IF budincamt(inctype) = 0 THEN GOTO 881
           
            CLS
            PRINT
            PRINT "New Budget Heading Created."
            PRINT
            PRINT "DESCRIPTION", "AMOUNT"
            PRINT budinc$(inctype), budincamt(inctype)
            PRINT
            PRINT "Next..."
            SLEEP
         END IF

         CLS
         PRINT
         PRINT "'"; idesc$(i); "' is the current description for this item."
         PRINT
         PRINT "Would you like to keep it, alter it, or skip it? (K/A/S)"
         PRINT
         PRINT "(IMPORTANT: Only change it by truncating some ending characters"
         PRINT "Otherwise, the next similiar item will not be associated with it."
         PRINT
         PRINT "Selecting 'S' is for one time expenses. Account item data"
         PRINT "will still be saved to the proper category, but the description"
         PRINT "will not be saved for future items."
         PRINT
         PRINT "(K/A/S)?"
        
         keeporalter$ = ""
347
         INPUT keeporalter$
         IF keeporalter$ = "" THEN GOTO 347
        
        
         IF keeporalter$ = "A" OR keeporalter$ = "a" THEN
            PRINT
            PRINT "Re-Enter the new description. (Remember, just truncate the end.)"
            INPUT idesc$(i)
         END IF

         'Find where to place new income description
         IF keeporalter$ <> "S" AND keeporalter$ <> "s" THEN
            firstopenplacefound = 0
            FOR y = 1 TO incdescperheading
               IF inccatdesc$(inctype, y) = "" AND firstopenplacefound = 0 THEN
                  inccatdesc$(inctype, y) = idesc$(i)
                  firstopenplacefound = y
               END IF
            NEXT y
         END IF


         'Assign item data to category
         x = inctype
         firstopenfound = 0
         FOR y = 1 TO numperincheading
            IF incdate$(x, y) = "" AND firstopenfound = 0 THEN
               incdate$(x, y) = idate$(i)
               incdesc$(x, y) = idesc$(i)
               IF icredit(i) = 0 THEN incamt(x, y) = idebit(i) * -1
               IF idebit(i) = 0 THEN incamt(x, y) = icredit(i)
               firstopenfound = 1
            END IF
         NEXT y
      END IF















      IF itemtype = 2 THEN
         CLS
         PRINT
         PRINT "Choose type of Fixed Expense:"
         PRINT "(Select next blank item to add a new category.)"
         PRINT
         PRINT "Item", "Type"
         FOR x = 1 TO fexpheadings
            PRINT x, budfexp$(x)
         NEXT x
         INPUT fexptype
         IF budfexp$(fexptype) = "" THEN 'this is a new type of budget heading
199
            PRINT
            PRINT "Enter a Heading for this new type of Fixed Expense."
            INPUT budfexp$(fexptype)
            PRINT
            PRINT budfexp$(fexptype)
            PRINT "Is this correct? (Y/N)"
          
            correct$ = ""
995
            INPUT correct$
            IF correct$ = "" THEN GOTO 995

            IF correct$ = "n" OR correct$ = "N" THEN GOTO 199
        
            PRINT
            PRINT "Now you must enter a budget amount for this heading."
            PRINT "You can edit this value later."
          
            budfexpamt(fexptype) = 0
880
            INPUT budfexpamt(fexptype)
            IF budfexpamt(fexptype) = 0 THEN GOTO 880
            CLS
            PRINT
            PRINT "New Budget Heading Created."
            PRINT
            PRINT "DESCRIPTION", "AMOUNT"
            PRINT budfexp$(fexptype), budfexpamt(fexptype)
            PRINT
            PRINT "Next..."
            SLEEP
        
        
         END IF
       
         CLS
         PRINT
         PRINT "'"; idesc$(i); "' is the current description for this item."
         PRINT
         PRINT "Would you like to keep it, alter it, or skip it? (K/A/S)"
         PRINT
         PRINT "(IMPORTANT: Only change it by truncating some ending characters"
         PRINT "Otherwise, the next similiar item will not be associated with it."
         PRINT
         PRINT "Selecting 'S' is for one time expenses. Account item data"
         PRINT "will still be saved to the proper category, but the description"
         PRINT "will not be saved for future items."
         PRINT
         PRINT "(K/A/S)?"

111
         keeporalter$ = ""
         INPUT keeporalter$
         IF keeporalter$ = "" THEN GOTO 111
        
         IF keeporalter$ = "A" OR keeporalter$ = "a" THEN
            PRINT
            PRINT "Re-Enter the new description. (Remember, just truncate the end.)"
            INPUT idesc$(i)
         END IF

         'Find where to place new fixed expense description
         IF keeporalter$ <> "S" AND keeporalter$ <> "s" THEN
            firstopenplacefound = 0
            x = fexptype ' Just check descriptions for this heading
            FOR y = 1 TO fexpdescperheading
               IF fexpcatdesc$(x, y) = "" AND firstopenplacefound = 0 THEN
                  fexpcatdesc$(x, y) = idesc$(i)
                  firstopenplacefound = y
               END IF
            NEXT y
         END IF

         'Assign account item data to new heading
         firstopenfound = 0
         x = fexptype
         FOR y = 1 TO numperfexpheading
            IF fexpdate$(x, y) = "" AND firstopenfound = 0 THEN
               fexpdate$(x, y) = idate$(i)
               fexpdesc$(x, y) = idesc$(i)
               IF icredit(i) = 0 THEN fexpamt(x, y) = idebit(i)
               IF idebit(i) = 0 THEN fexpamt(x, y) = icredit(i) * -1
               firstopenfound = 1
            END IF
         NEXT y

      END IF









      IF itemtype = 3 THEN
         CLS
         PRINT
         PRINT "Choose type of Variable Expense:"
         PRINT "(Select next blank item to add a new category.)"
         PRINT
         PRINT "Item", "Type"
         FOR x = 1 TO vexpheadings
            PRINT x, budvexp$(x)
         NEXT x
        
290      vexptype = 0
         INPUT vexptype
         IF vexptype = 0 THEN GOTO 290
        
         IF budvexp$(vexptype) = "" THEN 'this is a new type of budget heading
299
            PRINT
            PRINT "Enter a Heading for this new type of Variable Expense."
            INPUT budvexp$(vexptype)
            PRINT
            PRINT budvexp$(vexptype)
            PRINT "Is this correct? (Y/N)"
           
            correct$ = ""
990
            INPUT correct$
            IF correct$ = "" THEN GOTO 990

            IF correct$ = "n" OR correct$ = "N" THEN GOTO 299
            PRINT
            PRINT "Now you must enter a budget amount for this heading."
            PRINT "You can edit this value later."
           
            budvexpamt(vexptype) = 0
991
            INPUT budvexpamt(vexptype)
            IF budvexpamt(vexptype) = 0 THEN GOTO 991
            CLS
            PRINT
            PRINT "New Budget Heading Created."
            PRINT
            PRINT "DESCRIPTION", "AMOUNT"
            PRINT budvexp$(vexptype), budvexpamt(vexptype)
            PRINT
            PRINT "Next..."
            SLEEP
         END IF

         CLS
         PRINT
         PRINT "'"; idesc$(i); "' is the current description for this item."
         PRINT
         PRINT "Would you like to keep it, alter it, or skip it? (K/A/S)"
         PRINT
         PRINT "(IMPORTANT: Only change it by truncating some ending characters"
         PRINT "Otherwise, the next similiar item will not be associated with it."
         PRINT
         PRINT "Selecting 'S' is for one time expenses. Account item data"
         PRINT "will still be saved to the proper category, but the description"
         PRINT "will not be saved for future items."
         PRINT
         PRINT "(K/A/S)?"
          


         keeporalter$ = ""
777
         INPUT keeporalter$
         IF keeporalter$ = "" THEN GOTO 777
        
         IF keeporalter$ = "A" OR keeporalter$ = "a" THEN
            PRINT
            PRINT "Re-Enter the new description. (Remember, just truncate the end.)"
            INPUT idesc$(i)
         END IF

         'Find where to place new variable expense description
         x = vexptype ' Just check descriptions for this heading
         IF keeporalter$ <> "S" AND keeporalter$ <> "s" THEN
            firstopenplacefound = 0
            FOR y = 1 TO vexpdescperheading
               IF vexpcatdesc$(x, y) = "" AND firstopenplacefound = 0 THEN
                  vexpcatdesc$(x, y) = idesc$(i)
                  firstopenplacefound = y
               END IF
            NEXT y
         END IF
        
        
         'Assign account item data to new heading
         firstopenfound = 0
         FOR y = 1 TO numpervexpheading
            IF vexpdate$(x, y) = "" AND firstopenfound = 0 THEN
               vexpdate$(x, y) = idate$(i)
               vexpdesc$(x, y) = idesc$(i)
               IF icredit(i) = 0 THEN vexpamt(x, y) = idebit(i)
               IF idebit(i) = 0 THEN vexpamt(x, y) = icredit(i) * -1
               firstopenfound = 1
            END IF
         NEXT y
     
      END IF

   END IF
147
NEXT i

CLS
PRINT
PRINT "Account entries for file: "; account$; " have been categorized."
SLEEP


GOSUB savebudgetfile

RETURN















viewbudget:
IF budgetloaded = 0 THEN
   CLS
   PRINT
   PRINT "Please create or load a budget first!"
   SLEEP
   RETURN
END IF

GOSUB resetreportvalues
GOSUB getcattotals

CLS
PRINT
PRINT "VIEW BUDGET"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Account Files Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "INCOME"
PRINT
FOR x = 1 TO incheadings
   IF budinc$(x) <> "" THEN
      PRINT budinc$(x), budincamt(x)
   END IF
NEXT x
SLEEP



CLS
PRINT
PRINT "BUDGET REPORT"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Account Files Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "FIXED EXPENSES"
PRINT
FOR x = 1 TO fexpheadings
   IF budfexp$(x) <> "" THEN
      PRINT budfexp$(x), budfexpamt(x)
   END IF
NEXT x
SLEEP





CLS
PRINT
PRINT "BUDGET REPORT"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Account Files Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "VARIABLE EXPENSES"
PRINT
FOR x = 1 TO vexpheadings
   IF budvexp$(x) <> "" THEN
      PRINT budvexp$(x), budvexpamt(x)
   END IF
NEXT x
SLEEP

CLS
PRINT
PRINT "BUDGET REPORT"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Account Files Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "Total Income:           ", totbudinc
PRINT "Total Fixed Expenses:   ", totbudfexp
PRINT "Total Variable Expenses:", totbudvexp
PRINT
PRINT "Budget Surplus:         ", totbudinc - totbudfexp - totbudvexp
SLEEP



RETURN















loadbudgetfile:

budgetloaded = 1


'reset report values
GOSUB resetreportvalues


CLS
PRINT
PRINT "Available Budget Files:"
PRINT
CHDIR "D:\finance\basicp~2"
FILES "*.bud"
PRINT
PRINT "Please enter name of budget file to load."
PRINT "(Type name exactly as it appears above, but omit '.bud')"
INPUT budgetfile$
budgetfile$ = budgetfile$ + ".bud"

OPEN budgetfile$ FOR INPUT AS #1

LINE INPUT #1, accountscategorized$
LINE INPUT #1, lastdatecategorized$
'Budget Headings and Amounts
FOR x = 1 TO incheadings
   LINE INPUT #1, budinc$(x)
   LINE INPUT #1, amt$
   budincamt(x) = VAL(amt$)
NEXT x
FOR x = 1 TO fexpheadings
   LINE INPUT #1, budfexp$(x)
   LINE INPUT #1, amt$
   budfexpamt(x) = VAL(amt$)
NEXT x
FOR x = 1 TO vexpheadings
   LINE INPUT #1, budvexp$(x)
   LINE INPUT #1, amt$
   budvexpamt(x) = VAL(amt$)
NEXT x

'Amount Entries for Each Heading
FOR x = 1 TO incheadings
   FOR y = 1 TO numperincheading
      LINE INPUT #1, incdate$(x, y)
      LINE INPUT #1, incdesc$(x, y)
      LINE INPUT #1, income$
      incamt(x, y) = VAL(income$)
   NEXT y
NEXT x
FOR x = 1 TO fexpheadings
   FOR y = 1 TO numperfexpheading
      LINE INPUT #1, fexpdate$(x, y)
      LINE INPUT #1, fexpdesc$(x, y)
      LINE INPUT #1, fexpamount$
      fexpamt(x, y) = VAL(fexpamount$)
   NEXT y
NEXT x
FOR x = 1 TO vexpheadings
   FOR y = 1 TO numpervexpheading
      LINE INPUT #1, vexpdate$(x, y)
      LINE INPUT #1, vexpdesc$(x, y)
      LINE INPUT #1, vexpamount$
      vexpamt(x, y) = VAL(vexpamount$)
   NEXT y
NEXT x

'Library of Associated Descriptions (x = Heading)
FOR x = 1 TO incheadings
   FOR y = 1 TO incdescperheading
      LINE INPUT #1, inccatdesc$(x, y)
   NEXT y
NEXT x
FOR x = 1 TO fexpheadings
   FOR y = 1 TO fexpdescperheading
      LINE INPUT #1, fexpcatdesc$(x, y)
   NEXT y
NEXT x
FOR x = 1 TO vexpheadings
   FOR y = 1 TO vexpdescperheading
      LINE INPUT #1, vexpcatdesc$(x, y)
   NEXT y
NEXT x

CLOSE
RETURN
















currentreport:

'reset variables for report
GOSUB resetreportvalues


'Calculate category totals
GOSUB getcattotals

'Amount Entries for Each Heading
CLS
PRINT
PRINT " Categorized Totals According to Account Data Processed So Far:"
SLEEP

CLS
PRINT
PRINT "CURRENT ACCOUNT REPORT"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "INCOME HEADINGS and AMOUNTS"
PRINT
FOR x = 1 TO incheadings
   IF budinc$(x) <> "" THEN PRINT budinc$(x), catincamt(x)
NEXT x
SLEEP

CLS
PRINT
PRINT "CURRENT ACCOUNT REPORT"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "FIXED EXPENSE HEADINGS and AMOUNTS"
PRINT
FOR x = 1 TO fexpheadings
   IF budfexp$(x) <> "" THEN PRINT budfexp$(x), catfexpamt(x)
NEXT x
SLEEP

CLS
PRINT
PRINT "CURRENT ACCOUNT REPORT"
PRINT
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "VARIABLE EXPENSE HEADINGS and AMOUNTS"
PRINT
FOR x = 1 TO vexpheadings
   IF budvexp$(x) <> "" THEN PRINT budvexp$(x), catvexpamt(x)
NEXT x
SLEEP

PRINT
PRINT "Would you like a printout of this report? (Y/N)"
GOSUB yesorno

IF yesorno$ = "Y" OR yesorno$ = "y" THEN
   LPRINT
   LPRINT "=============================================================="
   LPRINT "Categorized Totals According to Account Data Processed So Far:"
   LPRINT
   LPRINT "CURRENT ACCOUNT REPORT"
   LPRINT
   LPRINT "Budget File: "; budgetfile$
   LPRINT
   LPRINT "Accounts Categorized: "; accountscategorized$
   LPRINT "Last Date Categorized: "; lastdatecategorized$
   LPRINT "=============================================================="
   LPRINT "INCOME HEADINGS and AMOUNTS"
   LPRINT
   FOR x = 1 TO incheadings
      IF budinc$(x) <> "" THEN LPRINT budinc$(x), catincamt(x)
   NEXT x
  
   LPRINT
   LPRINT "=============================================================="
   LPRINT "FIXED EXPENSE HEADINGS and AMOUNTS"
   LPRINT
   FOR x = 1 TO fexpheadings
      IF budfexp$(x) <> "" THEN LPRINT budfexp$(x), catfexpamt(x)
   NEXT x
  
   LPRINT
   LPRINT "=============================================================="
   LPRINT "VARIABLE EXPENSE HEADINGS and AMOUNTS"
   LPRINT
   FOR x = 1 TO vexpheadings
   IF budvexp$(x) <> "" THEN LPRINT budvexp$(x), catvexpamt(x)
   NEXT x
END IF

RETURN

    

compare:

'reset variables for report
GOSUB resetreportvalues

'Calculate catagory totals
GOSUB getcattotals


CLS
PRINT
PRINT "REPORT COMPARING CURRENT AMOUNTS WITH BUDGET AMOUNTS"
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "INCOME"
PRINT "HEADING", "BUDGET AMT", "CURRENT AMT", "DIFFERENCE"
FOR x = 1 TO incheadings
   IF budinc$(x) <> "" THEN PRINT budinc$(x), budincamt(x), catincamt(x), catincamt(x) - budincamt(x)
NEXT x
SLEEP

CLS
PRINT
PRINT "REPORT COMPARING CURRENT AMOUNTS WITH BUDGET AMOUNTS"
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "FIXED EXPENSES"
PRINT "HEADING", "BUDGET AMT", "CURRENT AMT", "REMAINING"
FOR x = 1 TO fexpheadings
   IF budfexp$(x) <> "" THEN PRINT budfexp$(x), budfexpamt(x), catfexpamt(x), budfexpamt(x) - catfexpamt(x)
NEXT x
SLEEP

CLS
PRINT
PRINT "REPORT COMPARING CURRENT AMOUNTS WITH BUDGET AMOUNTS"
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "VARIABLE EXPENSES"
PRINT "HEADING", "BUDGET AMT", "CURRENT AMT", "REMAINING"
FOR x = 1 TO vexpheadings
   IF budvexp$(x) <> "" THEN PRINT budvexp$(x), budvexpamt(x), catvexpamt(x), budvexpamt(x) - catvexpamt(x)
NEXT x
SLEEP

'Condensed Report
CLS
PRINT
PRINT "CONDENSED COMPARISON REPORT"
PRINT "Budget File: "; budgetfile$
PRINT
PRINT "Accounts Categorized: "; accountscategorized$
PRINT "Last Date Categorized: "; lastdatecategorized$
PRINT
PRINT "INCOME"
PRINT "Budget Tot:", totbudinc
PRINT "Current Tot:", totinc
PRINT "Difference:", totinc - totbudinc
SLEEP

PRINT
PRINT "FIXED EXPENSES"
PRINT "Budget Tot:", totbudfexp
PRINT "Current Tot:", totfexp
PRINT "Remaining:", totbudfexp - totfexp
SLEEP

PRINT
PRINT "VARIABLE EXPENSES"
PRINT "Budget Tot:", totbudvexp
PRINT "Current Tot:", totvexp
PRINT "Remaining:", totbudvexp - totvexp
SLEEP

PRINT
PRINT "Budget Surplus:", (totinc - totbudinc) + (totbudfexp - totfexp) + (totbudvexp - totvexp)
SLEEP

PRINT
PRINT "Would you like a printout of this report? (Y/N)"
GOSUB yesorno

IF yesorno$ = "Y" OR yesorno$ = "y" THEN

   LPRINT "===================================================="
   LPRINT "REPORT COMPARING CURRENT AMOUNTS WITH BUDGET AMOUNTS"
   LPRINT "Budget File: "; budgetfile$
   LPRINT
   LPRINT "Accounts Categorized: "; accountscategorized$
   LPRINT "Last Date Categorized: "; lastdatecategorized$
   LPRINT
   LPRINT "INCOME"
   LPRINT "HEADING", "BUDGET AMT", "CURRENT AMT", "DIFFERENCE"
   FOR x = 1 TO incheadings
      IF budinc$(x) <> "" THEN LPRINT budinc$(x), budincamt(x), catincamt(x), catincamt(x) - budincamt(x)
   NEXT x
   
   LPRINT
   LPRINT "FIXED EXPENSES"
   LPRINT "HEADING", "BUDGET AMT", "CURRENT AMT", "REMAINING"
   FOR x = 1 TO fexpheadings
      IF budfexp$(x) <> "" THEN LPRINT budfexp$(x), budfexpamt(x), catfexpamt(x), budfexpamt(x) - catfexpamt(x)
   NEXT x
   
   LPRINT
   LPRINT "VARIABLE EXPENSES"
   LPRINT "HEADING", "BUDGET AMT", "CURRENT AMT", "REMAINING"
   FOR x = 1 TO vexpheadings
      IF budvexp$(x) <> "" THEN LPRINT budvexp$(x), budvexpamt(x), catvexpamt(x), budvexpamt(x) - catvexpamt(x)
   NEXT x
   
   'Condensed Report
   LPRINT
   LPRINT "====================================================="
   LPRINT "CONDENSED COMPARISON REPORT"
   LPRINT "Budget File: "; budgetfile$
   LPRINT
   LPRINT "INCOME"
   LPRINT "Budget Tot:", totbudinc
   LPRINT "Current Tot:", totinc
   LPRINT "Difference:", totinc - totbudinc
   
   LPRINT
   LPRINT "FIXED EXPENSES"
   LPRINT "Budget Tot:", totbudfexp
   LPRINT "Current Tot:", totfexp
   LPRINT "Remaining:", totbudfexp - totfexp
   
   LPRINT
   LPRINT "VARIABLE EXPENSES"
   LPRINT "Budget Tot:", totbudvexp
   LPRINT "Current Tot:", totvexp
   LPRINT "Remaining:", totbudvexp - totvexp
   
   LPRINT
   LPRINT "Budget Surplus:", (totinc - totbudinc) + (totbudfexp - totfexp) + (totbudvexp - totvexp)
   LPRINT "====================================================="
END IF

RETURN

     


viewdescriptions:
'Library of Associated Descriptions (x = Heading)
CLS
PRINT
PRINT "List of Heading Descriptions"
PRINT
PRINT "INCOME Descriptions"
FOR x = 1 TO incheadings
   IF budinc$(x) <> "" THEN
      PRINT "For Income Heading: "; budinc$(x)
      FOR y = 1 TO incdescperheading
         IF inccatdesc$(x, y) <> "" THEN
            PRINT inccatdesc$(x, y)
            SLEEP
         END IF
      NEXT y
   END IF
   PRINT
NEXT x
SLEEP

CLS
PRINT
      PRINT "List of Heading Descriptions"
      PRINT
      PRINT "FIXED EXPENSE Descriptions"
      FOR x = 1 TO fexpheadings
   IF budfexp$(x) <> "" THEN
      PRINT "For Fixed Expense Heading: "; budfexp$(x)
      FOR y = 1 TO fexpdescperheading
         IF fexpcatdesc$(x, y) <> "" THEN
            PRINT fexpcatdesc$(x, y)
            SLEEP
         END IF
      NEXT y
            

   END IF
   PRINT
NEXT x
SLEEP

CLS
PRINT
PRINT "List of Heading Descriptions"
PRINT
PRINT "VARIABLE EXPENSE Descriptions"
FOR x = 1 TO vexpheadings
   IF budvexp$(x) <> "" THEN
      PRINT
      PRINT "For Variable Expense Heading: "; budvexp$(x)
      FOR y = 1 TO vexpdescperheading
         IF vexpcatdesc$(x, y) <> "" THEN
            PRINT vexpcatdesc$(x, y)
            SLEEP
         END IF
      NEXT y
   END IF
   PRINT
NEXT x
SLEEP

RETURN











editbudgetfile:

IF budgetloaded = 0 THEN
   CLS
   PRINT
   PRINT "Please create or load a budget first!"
   SLEEP
   RETURN
END IF


CLS
PRINT
PRINT "Edit Budget File Routine"
PRINT
PRINT "Which item do you wish to edit?"
PRINT
PRINT "1. Income"
PRINT "2. Fixed Expense"
PRINT "3. Variable Expense"
PRINT
INPUT itemchoice

IF itemchoice = 1 THEN GOSUB editincome
IF itemchoice = 2 THEN GOSUB editfexp
IF itemchoice = 3 THEN GOSUB editvexp


'Save editted file
GOSUB savebudgetfile

PRINT
PRINT "Budget File '"; budgetfile$; " has been editted and saved."
PRINT
PRINT "Next..."
SLEEP

RETURN



















editincome:
CLS
PRINT
PRINT "Editing Income Data"
PRINT
PRINT "Current Data"
PRINT
PRINT "Item", "Description", "Amount"
FOR x = 1 TO incheadings
   PRINT x, budinc$(x), budincamt(x)
NEXT x

20
PRINT
PRINT "Please enter the item number you wish to edit."
INPUT itemnumber
PRINT "Please enter the new description."
INPUT budinc$(itemnumber)
PRINT "Please enter the new amount."
INPUT budincamt(itemnumber)

CLS
PRINT
PRINT "Editted Income Data"
PRINT
PRINT "Item", "Description", "Amount"
FOR x = 1 TO incheadings
   PRINT x, budinc$(x), budincamt(x)
NEXT x
PRINT
PRINT "Is this OK? (Y/N)"
INPUT ok$
IF ok$ = "Y" OR ok$ = "y" THEN RETURN
GOTO 20

















editfexp:
CLS
PRINT
PRINT "Editing Fixed Expense Data"
PRINT
PRINT "Current Data"
PRINT
PRINT "Item", "Description", "Amount"
FOR x = 1 TO fexpheadings
   PRINT x, budfexp$(x), budfexpamt(x)
NEXT x

30
PRINT
PRINT "Please enter the item number you wish to edit."
INPUT itemnumber
PRINT "Please enter the new description."
INPUT budfexp$(itemnumber)
PRINT "Please enter the new amount."
INPUT budfexpamt(itemnumber)

PRINT "Editted Fixed Expense Data"
PRINT
PRINT "Item", "Description", "Amount"
FOR x = 1 TO fexpheadings
   PRINT x, budfexp$(x), budfexpamt(x)
NEXT x
PRINT
PRINT "Is this OK? (Y/N)"
INPUT ok$
IF ok$ = "Y" OR ok$ = "y" THEN RETURN
GOTO 30
















editvexp:
CLS
PRINT
PRINT "Editing Variable Expense Data"
PRINT
PRINT "Current Data"
PRINT
PRINT "Item", "Description", "Amount"
FOR x = 1 TO vexpheadings
   PRINT x, budvexp$(x), budvexpamt(x)
NEXT x

40
PRINT
PRINT "Please enter the item number you wish to edit."
INPUT itemnumber
PRINT "Please enter the new description. (K for Keep)"
INPUT new$

IF new$ <> "K" AND new$ <> "k" THEN budvexp$(itemnumber) = new$

PRINT "Please enter the new amount."
INPUT budvexpamt(itemnumber)

PRINT "Editted Variable Expense Data"
PRINT
PRINT "Item", "Description", "Amount"
FOR x = 1 TO vexpheadings
   PRINT x, budvexp$(x), budvexpamt(x)
NEXT x
PRINT
PRINT "Is this OK? (Y/N)"
INPUT ok$
IF ok$ = "Y" OR ok$ = "y" THEN RETURN
GOTO 40


















createbudgetfile:
budgetloaded = 1

'reset report values
GOSUB resetreportvalues

CLS
PRINT
PRINT "Create Budget File Routine"
PRINT
PRINT "Enter name of budget file. (budyymm or master, omit .bud)"
INPUT newbudgetfile$

budgetfile$ = newbudgetfile$ + ".bud"

CLS
PRINT
PRINT "INCOME"
PRINT
FOR x = 1 TO incheadings
   PRINT "Enter an income heading. (Enter 999 if finished)"
   INPUT budinc$(x)
   IF budinc$(x) = "999" THEN
      budinc$(x) = ""
      GOTO 50
   END IF
   PRINT "Enter amount for that heading. (no $, decimal, or cents)"
   INPUT budincamt(x)
NEXT x
50

CLS
PRINT
PRINT "FIXED EXPENSES"
PRINT
FOR x = 1 TO fexpheadings
   PRINT "Enter a fixed expense heading. (Enter 999 if finished)"
   INPUT budfexp$(x)
   IF budfexp$(x) = "999" THEN
      budfexp$(x) = ""
      GOTO 60
   END IF
   PRINT "Enter amount for that heading. (no $, decimal, or cents)"
   INPUT budfexpamt(x)
NEXT x
60

CLS
PRINT
PRINT "VARIABLE EXPENSES"
PRINT
FOR x = 1 TO vexpheadings
   PRINT "Enter a variable expense heading. (Enter 999 if finished)"
   INPUT budvexp$(x)
   IF budvexp$(x) = "999" THEN
      budvexp$(x) = ""
      GOTO 70
   END IF
   PRINT "Enter amount for that heading. (no $, decimal, or cents)"
   INPUT budvexpamt(x)
NEXT x
70

GOSUB savebudgetfile
CLS
PRINT
PRINT "Budget Data has been created and saved."
PRINT "File Name is: "; budgetfile$
PRINT
PRINT "Next..."
SLEEP

RETURN
















savebudgetfile:

IF budgetloaded = 0 THEN
   CLS
   PRINT
   PRINT "Please create or load a budget first!"
   SLEEP
   RETURN
END IF


CLS
PRINT
PRINT "Saving Current Budget File."
PRINT
PRINT "Current Budget File Name is: "; budgetfile$
PRINT
PRINT "Do you wish to keep this name or alter it? (K/A)"

456
keep$ = ""
INPUT keep$
IF keep$ = "" THEN GOTO 456

IF keep$ = "A" OR keep$ = "a" THEN
   PRINT
   PRINT "Enter new budget file name. (budYYMM or master. Do not enter a file type.)"

457
   budgetfile$ = ""
   INPUT budgetfile$
   IF budgetfile$ = "" THEN GOTO 457

   budgetfile$ = budgetfile$ + ".bud"


END IF

PRINT
PRINT "Do you wish to save account data? (Y/N)."
PRINT "(Choosing 'N' will create a master budget file with only budget and"
PRINT "descriptions to associate, i.e. all categories will be nil.)"

458
saveaccountdata$ = ""
INPUT saveaccountdata$
IF saveaccountdata$ = "" THEN GOTO 458

saveasmaster = 0
IF saveaccountdata$ = "N" OR saveaccountdata$ = "n" THEN saveasmaster = 1



OPEN budgetfile$ FOR OUTPUT AS #1

PRINT #1, accountscategorized$
PRINT #1, lastdatecategorized$
'Budget Headings and Amounts
FOR x = 1 TO incheadings
   PRINT #1, budinc$(x)
   PRINT #1, budincamt(x)
NEXT x
FOR x = 1 TO fexpheadings
   PRINT #1, budfexp$(x)
   PRINT #1, budfexpamt(x)
NEXT x
FOR x = 1 TO vexpheadings
   PRINT #1, budvexp$(x)
   PRINT #1, budvexpamt(x)
NEXT x

'Amount Entries for Each Heading
FOR x = 1 TO incheadings
   FOR y = 1 TO numperincheading
      IF saveasmaster = 0 THEN
         PRINT #1, incdate$(x, y)
         PRINT #1, incdesc$(x, y)
         PRINT #1, incamt(x, y)
      ELSE
         PRINT #1, ""
         PRINT #1, ""
         PRINT #1, 0
      END IF
   NEXT y
NEXT x
FOR x = 1 TO fexpheadings
   FOR y = 1 TO numperfexpheading
      IF saveasmaster = 0 THEN
         PRINT #1, fexpdate$(x, y)
         PRINT #1, fexpdesc$(x, y)
         PRINT #1, fexpamt(x, y)
      ELSE
         PRINT #1, ""
         PRINT #1, ""
         PRINT #1, 0
      END IF
   NEXT y
NEXT x
FOR x = 1 TO vexpheadings
   FOR y = 1 TO numpervexpheading
      IF saveasmaster = 0 THEN
         PRINT #1, vexpdate$(x, y)
         PRINT #1, vexpdesc$(x, y)
         PRINT #1, vexpamt(x, y)
      ELSE
         PRINT #1, ""
         PRINT #1, ""
         PRINT #1, 0
      END IF
   NEXT y
NEXT x

'Library of Associated Descriptions (x = Heading)
FOR x = 1 TO incheadings
   FOR y = 1 TO incdescperheading
      PRINT #1, inccatdesc$(x, y)
   NEXT y
NEXT x
FOR x = 1 TO fexpheadings
   FOR y = 1 TO fexpdescperheading
      PRINT #1, fexpcatdesc$(x, y)
   NEXT y
NEXT x
FOR x = 1 TO vexpheadings
   FOR y = 1 TO vexpdescperheading
      PRINT #1, vexpcatdesc$(x, y)
   NEXT y
NEXT x
CLOSE

RETURN















editdescriptions:
333
CLS
PRINT
PRINT "Category Types"
PRINT
PRINT "1. Income"
PRINT "2. Fixed Expenses"
PRINT "3. Variable Expenses"
PRINT
PRINT "What type of descriptions would you like to view/edit?"

898
desctype = 0
INPUT desctype
IF desctype = 0 THEN GOTO 898

IF desctype = 1 THEN
   FOR x = 1 TO incheadings
      CLS
      PRINT
      PRINT "INCOME DESCRIPTIONS"
      PRINT "Heading: "; budinc$(x)
      PRINT
      FOR y = 1 TO incdescperheading
         IF inccatdesc$(x, y) <> "" THEN PRINT y; ". "; inccatdesc$(x, y)
         SLEEP
      NEXT y
      PRINT
      PRINT "Do you want to edit one of these descriptions? (Y/N)"

      GOSUB yesorno

      IF yesorno$ = "Y" OR yesorno$ = "y" THEN
6681    
         PRINT
         PRINT "What number description do you want to edit?"

         editnum = 0
669
         INPUT editnum
         IF editnum = 0 THEN GOTO 669
  
         PRINT
         PRINT "Income Heading: "; budinc$(x)
         PRINT "Description To Edit: "; inccatdesc$(x, editnum)
         PRINT
         PRINT "Is this the correct description to edit? (Y/N)"

         GOSUB yesorno

         IF yesorno$ = "N" OR yesorno$ = "n" THEN GOTO 6681
788     
         PRINT
         PRINT "Enter New Description"

         GOSUB getstring

         PRINT
         PRINT getstring$
         PRINT "Is this correct? (Y/N)"
         GOSUB yesorno
         IF yesorno$ = "N" OR yesorno$ = "n" THEN GOTO 788

         inccatdesc$(x, editnum) = getstring$
      END IF
   NEXT x
END IF

IF desctype = 2 THEN
   FOR x = 1 TO fexpheadings
      CLS
      PRINT
      PRINT "FIXED EXPENSE DESCRIPTIONS"
      PRINT "Heading: "; budfexp$(x)
      PRINT
      FOR y = 1 TO fexpdescperheading
         IF fexpcatdesc$(x, y) <> "" THEN PRINT y; ". "; fexpcatdesc$(x, y)
         SLEEP
      NEXT y
      PRINT
      PRINT "Do you want to edit one of these descriptions? (Y/N)"

      GOSUB yesorno

      IF yesorno$ = "Y" OR yesorno$ = "y" THEN
66812 
         PRINT
         PRINT "What number description do you want to edit?"

         editnum = 0
6692
         INPUT editnum
         IF editnum = 0 THEN GOTO 6692
 
         PRINT
         PRINT "Fixed Expense Heading: "; budfexp$(x)
         PRINT "Description To Edit: "; fexpcatdesc$(x, editnum)
         PRINT
         PRINT "Is this the correct description to edit? (Y/N)"

         GOSUB yesorno

         IF yesorno$ = "N" OR yesorno$ = "n" THEN GOTO 66812
7882   
         PRINT
         PRINT "Enter New Description"

         GOSUB getstring

         PRINT
         PRINT getstring$
         PRINT "Is this correct? (Y/N)"
         GOSUB yesorno
         IF yesorno$ = "N" OR yesorno$ = "n" THEN GOTO 7882

         fexpcatdesc$(x, editnum) = getstring$
      END IF
   NEXT x
END IF

IF desctype = 3 THEN
   FOR x = 1 TO vexpheadings
      CLS
      PRINT
      PRINT "VARIABLE EXPENSE DESCRIPTIONS"
      PRINT "Heading: "; budvexp$(x)
      PRINT
      FOR y = 1 TO vexpdescperheading
         IF vexpcatdesc$(x, y) <> "" THEN PRINT y; ". "; vexpcatdesc$(x, y)
         SLEEP
      NEXT y
      PRINT
      PRINT "Do you want to edit one of these descriptions? (Y/N)"

      GOSUB yesorno

      IF yesorno$ = "Y" OR yesorno$ = "y" THEN
66813 
         PRINT
         PRINT "What number description do you want to edit?"

         editnum = 0
6693
         INPUT editnum
         IF editnum = 0 THEN GOTO 6693
 
         PRINT
         PRINT "Variable Expense Heading: "; budvexp$(x)
         PRINT "Description To Edit: "; vexpcatdesc$(x, editnum)
         PRINT
         PRINT "Is this the correct description to edit? (Y/N)"

         GOSUB yesorno

         IF yesorno$ = "N" OR yesorno$ = "n" THEN GOTO 66813
7883   
         PRINT
         PRINT "Enter New Description"

         GOSUB getstring

         PRINT
         PRINT getstring$
         PRINT "Is this correct? (Y/N)"
         GOSUB yesorno
         IF yesorno$ = "N" OR yesorno$ = "n" THEN GOTO 788

         vexpcatdesc$(x, editnum) = getstring$
      END IF
   NEXT x
END IF

RETURN







IF desctype = 1 THEN
   CLS
   PRINT
   PRINT "INCOME TYPES:"
   PRINT
   FOR x = 1 TO incheadings
      IF budinc$(x) <> "" THEN PRINT x; ". "; budinc$(x)
   NEXT x
   PRINT
   PRINT "What type of Income Description would you like to view/edit?"

135
   incdesctype = 0
   INPUT incdesctype
   IF incdesctype = 0 THEN GOTO 135
   IF budinc$(incdesctype) = "" THEN GOTO 135

   CLS
   PRINT
   PRINT "Income Descriptions for: "; budinc$(incdesctype)
   FOR y = 1 TO incdescperheading
      IF inccatdesc$(incdesctype, y) <> "" THEN
         PRINT y; ". "; inccatdesc$(incdesctype, y)
         SLEEP
      END IF
   NEXT y
   PRINT
   PRINT "Which description do you want to edit?"

975
   desctoedit = 0
   INPUT desctoedit
   IF desctoedit = 0 THEN GOTO 975
   IF inccatdesc$(incdesctype, desctoedit) = "" THEN GOTO 975

   PRINT
   PRINT "Enter new description for: "; budinc$(incdesctype)
   PRINT "(Enter 'del' to delete description)"

   inccatdesc$(incdesctype, desctoedit) = ""
246
   INPUT inccatdesc(incdesctype, desctoedit)
   IF inccatdesc$(incdesctype, desctoedit) = "" THEN GOTO 246

   IF inccatdesc$(incdesctype, desctoedit) = "del" THEN inccatdesc$(incdesctype, desctoedit) = ""
  
   PRINT
   PRINT "Finished Edits? (Y/N)"

258
  finished$ = ""
  INPUT finished$
  IF finished$ = "" THEN GOTO 258

  IF finished$ = "N" OR finished$ = "n" THEN GOTO 333
END IF














IF desctype = 2 THEN
   CLS
   PRINT
   PRINT "FIXED EXPENSE TYPES:"
   PRINT
   FOR x = 1 TO fexpheadings
      IF budfexp$(x) <> "" THEN PRINT x; ". "; budfexp$(x)
   NEXT x
   PRINT
   PRINT "What type of Fixed Expense Description would you like to view/edit?"

136
   fexpdesctype = 0
   INPUT fexpdesctype
   IF fexpdesctype = 0 THEN GOTO 136
   IF budfexp$(fexpdesctype) = "" THEN GOTO 136

   CLS
   PRINT
   PRINT "Fixed Expense Descriptions for: "; budfexp$(fexpdesctype)
   FOR y = 1 TO fexpdescperheading
      IF fexpcatdesc$(fexpdesctype, y) <> "" THEN
         PRINT y; ". "; fexpcatdesc$(fexpdesctype, y)
         SLEEP
      END IF
   NEXT y
   PRINT
   PRINT "Which description do you want to edit?"

976
   desctoedit = 0
   INPUT desctoedit
   IF desctoedit = 0 THEN GOTO 976
   IF fexpcatdesc$(fexpdesctype, desctoedit) = "" THEN GOTO 976

   PRINT
   PRINT "Enter new description for: "; budfexp$(fexpdesctype)
   PRINT "(Enter 'del' to delete description)"

   fexpcatdesc$(fexpdesctype, desctoedit) = ""
247
   INPUT fexpcatdesc$(fexpdesctype, desctoedit)
   IF fexpcatdesc$(fexpdesctype, desctoedit) = "" THEN GOTO 247

   IF fexpcatdesc$(fexpdesctype, desctoedit) = "del" THEN fexpcatdesc$(fexpdesctype, desctoedit) = ""

   PRINT
   PRINT "Finished Edits? (Y/N)"

259
  finished$ = ""
  INPUT finished$
  IF finished$ = "" THEN GOTO 259

  IF finished$ = "N" OR finished$ = "n" THEN GOTO 333
END IF
















IF desctype = 3 THEN
   CLS
   PRINT
   PRINT "VARIABLE EXPENSE TYPES:"
   PRINT
   FOR x = 1 TO vexpheadings
      IF budvexp$(x) <> "" THEN PRINT x; ". "; budvexp$(x)
   NEXT x
   PRINT
   PRINT "What type of Variable Expense Description would you like to view/edit?"

137
   vexpdesctype = 0
   INPUT vexpdesctype
   IF vexpdesctype = 0 THEN GOTO 137
   IF budvexp$(vexpdesctype) = "" THEN GOTO 137

   CLS
   PRINT
   PRINT "Variable Expense Descriptions for: "; budvexp$(vexpdesctype)
   FOR y = 1 TO vexpdescperheading
      IF vexpcatdesc$(vexpdesctype, y) <> "" THEN
         PRINT y; ". "; vexpcatdesc$(vexpdesctype, y)
         SLEEP
      END IF
   NEXT y
   PRINT
   PRINT "Which description do you want to edit?"

977                                
   desctoedit = 0
   INPUT desctoedit
   IF desctoedit = 0 THEN GOTO 977
   IF vexpcatdesc$(vexpdesctype, desctoedit) = "" THEN GOTO 977

   PRINT
   PRINT "Enter new description for: "; budvexp$(vexpdesctype)
   PRINT "(Enter 'del' to delete description)"

   vexpcatdesc$(vexpdesctype, desctoedit) = ""
248
   INPUT vexpcatdesc$(vexpdesctype, desctoedit)
   IF vexpcatdesc$(vexpdesctype, desctoedit) = "" THEN GOTO 248

   IF vexpcatdesc$(vexpdesctype, desctoedit) = "del" THEN vexpcatdesc$(vexpdesctype, desctoedit) = ""

   PRINT
   PRINT "Finished Edits? (Y/N)"

260
  finished$ = ""
  INPUT finished$
  IF finished$ = "" THEN GOTO 260

  IF finished$ = "N" OR finished$ = "n" THEN GOTO 333
END IF

GOSUB savebudgetfile

RETURN



getcattotals:

FOR x = 1 TO incheadings
   FOR y = 1 TO numperincheading
      catincamt(x) = catincamt(x) + incamt(x, y)
      totinc = totinc + incamt(x, y)
   NEXT y
   totbudinc = totbudinc + budincamt(x)
NEXT x

FOR x = 1 TO fexpheadings
   FOR y = 1 TO numperfexpheading
      catfexpamt(x) = catfexpamt(x) + fexpamt(x, y)
      totfexp = totfexp + fexpamt(x, y)
   NEXT y
   totbudfexp = totbudfexp + budfexpamt(x)
NEXT x
FOR x = 1 TO vexpheadings
   FOR y = 1 TO numpervexpheading
      catvexpamt(x) = catvexpamt(x) + vexpamt(x, y)
      totvexp = totvexp + vexpamt(x, y)
   NEXT y
   totbudvexp = totbudvexp + budvexpamt(x)
NEXT x

RETURN

yesorno:

yesorno$ = ""
123
INPUT yesorno$
IF yesorno$ = "" THEN GOTO 123

RETURN

getstring:

getstring$ = ""
234
INPUT getstring$
IF getstring$ = "" THEN GOTO 234
RETURN



resetreportvalues:

totinc = 0
totfexp = 0
totvexp = 0
totbudinc = 0
totbudfexp = 0
totbudvexp = 0

FOR x = 1 TO incheadings
   catincamt(x) = 0
NEXT x
FOR x = 1 TO fexpheadings
   catfexpamt(x) = 0
NEXT x
FOR x = 1 TO vexpheadings
   catvexpamt(x) = 0
NEXT x

RETURN


'END OF SUB-ROUTINES

